// WBLibCheckerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WBLibChecker.h"
#include "WBLibCheckerDlg.h"
#include ".\wblibcheckerdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CWBLibCheckerDlg dialog



CWBLibCheckerDlg::CWBLibCheckerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWBLibCheckerDlg::IDD, pParent)
	, m_dbRGain(1.0)
	, m_dbBGain(1.0)
	, m_dbGrGain(1.0)
	, m_dbGbGain(1.0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWBLibCheckerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_FILENAME_EDIT, m_clFileNameEdit);
	DDX_Text(pDX, IDC_RGAIN_STATIC, m_dbRGain);
	DDX_Text(pDX, IDC_BGAIN_STATIC, m_dbBGain);
	DDX_Text(pDX, IDC_GRGAIN_STATIC, m_dbGrGain);
	DDX_Text(pDX, IDC_GBGAIN_STATIC, m_dbGbGain);

}

BEGIN_MESSAGE_MAP(CWBLibCheckerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_OPEN_BUTTON, OnBnClickedOpenButton)
END_MESSAGE_MAP()


// CWBLibCheckerDlg message handlers

BOOL CWBLibCheckerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWBLibCheckerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWBLibCheckerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWBLibCheckerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CWBLibCheckerDlg::OnBnClickedOpenButton()
{
	CString csFile;
	HMODULE hDLL = NULL;
	m_clFileNameEdit.GetWindowText( csFile );

	CFileDialog	dglFile( TRUE, NULL, csFile, OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, "NEF Files (*.nef)|*.nef||", this);
				
	if( dglFile.DoModal() == IDOK )
	{
		m_clFileNameEdit.SetWindowText( dglFile.GetPathName() );

		//Load File Header from file
		FILE* pOpenFile = fopen(dglFile.GetPathName().GetBuffer(),"rb");
		unsigned char arFileHeader[10240];
		fread(arFileHeader,1,10240,pOpenFile);
		fclose(pOpenFile);
		unsigned long ulResult = NkWBGetWBGain( arFileHeader,sizeof(arFileHeader), &m_dbRGain, &m_dbBGain, &m_dbGrGain, &m_dbGbGain );
		UpdateData(false);

		if (hDLL != NULL)
			FreeLibrary(hDLL);
	}
}

